## sa-exim 4.0

=== Makefile ===
# SA-Exim can be built standalone as a loadable module with this Makefile
# or you can copy sa-exim.c over exim's local_scan.c file if you want to
# statically build it into exim
#

VERSION=$(shell cat version)

# The idea is that you don't have to edit these values, you can override
# them on the command line:
# make SACONF=/etc/exim/sa-exim.conf LDFLAGS="-shared -fPIC" CC=cc
CC=gcc
CFLAGS=-O2 -Wall
LDFLAGS=-shared
SACONF=/etc/exim4/sa-exim.conf
SPAMC=/usr/bin/spamc


# I place the directory in exim/debian/local_scan. Adjust the path as needed
# Actually, we will also look for the versions supplied with this source
# if we can't find the exim source
EXIM_SRC= ../../src
EXIM_SRC_LOCAL = ./eximinc
SUFF=-$(VERSION)

SAFLAGS=-DSPAMASSASSIN_CONF=\"$(SACONF)\" -DSPAMC_LOCATION=\"$(SPAMC)\"
BUILDCFLAGS=-I$(EXIM_SRC) -I$(EXIM_SRC_LOCAL) -DDLOPEN_LOCAL_SCAN $(SAFLAGS) $(CFLAGS)

SONAME=$(subst .so,$(SUFF).so,sa-exim.so)

DOCS=sa.html CHANGELOG ACKNOWLEDGEMENTS
OBJECTS=$(SONAME) accept.so sa-exim_short.conf $(DOCS)
OTHERTARGETS=sa-exim.h

all: $(OBJECTS)

docs: $(DOCS)
	

$(SONAME) : sa-exim.c sa-exim.h
	@echo "Building $@"
	$(CC) $(BUILDCFLAGS) $(LDFLAGS) -o $@ $<
	chmod a+rx $(SONAME)

accept.so: accept.c
	@echo "Building $@"
	$(CC) $(BUILDCFLAGS) $(LDFLAGS) -o $@ $<
	chmod a+rx $@

ACKNOWLEDGEMENTS: Acknowledgements.html
	@echo "Generating $@"
	@lynx -dump -nolist $< > $@

CHANGELOG: Changelog.html
	@echo "Generating $@"
	@lynx -dump -nolist $< > $@

sa.html: Changelog.html Acknowledgements.html sa.html.template
	@echo "Generating $@"
	@bash -c 'sed "/<Changelog>/,$$ d" < sa.html.template; cat Changelog.html; sed "1,/<\/Changelog>/ d; /<Acknowledgements>/,$$ d" < sa.html.template; cat Acknowledgements.html; sed "1,/<\/Acknowledgements>/ d" < sa.html.template' > sa.html

sa-exim_short.conf: sa-exim.conf
	@cat sa-exim.conf | sed "/# --- snip ---/,$$ d" > sa-exim_short.conf
	@cat sa-exim.conf | grep -v "^#" | tr '\012' '' | sed "s/*//g" | tr '' '\012' >> sa-exim_short.conf

sa-exim.h: sa-exim.c version
	echo "char *version=\"`cat version` (built `date -R`)\";" > sa-exim.h

clean:	
	@-rm -rf $(OBJECTS) $(DOCS) $(OTHERTARGETS) build-stamp configure-stamp debian/sa-exim debian/sa-exim.postrm.debhelper debian/sa-exim.substvars debian/files 2>/dev/null

deb:	../sa-exim_$(VERSION).orig.tar.gz debian/*
	@make clean
	@dpkg-buildpackage -uc -us -sd -rfakeroot

../sa-exim_$(VERSION).orig.tar.gz: * */*
	@make clean
	@( cd ..; tar chvzf sa-exim_$(VERSION).orig.tar.gz sa-exim-$(VERSION) )

# This didn't work too well, I'll just ship the source with the debian tree
#deb:	../sa-exim_$(VERSION).orig.tar.gz debian/rules
#	@make clean
#	@dpkg-buildpackage -uc -us -sd -rfakeroot
#
#
#../sa-exim_$(VERSION).tar.gz: * */*
#	@make clean
#	@if [ -d debian ]; then echo "Can't rebuild $@ with debian tree unpacked, please remove it"; exit 1; fi
#	@( cd ..; tar chvzf sa-exim_$(VERSION).tar.gz sa-exim-$(VERSION) )
#
#
#../sa-exim_$(VERSION).orig.tar.gz: ../sa-exim_$(VERSION).tar.gz
#	if [ -e ../sa-exim-$(VERSION).tar.gz ] ; then \
#	    cp -a ../sa-exim-$(VERSION).tar.gz ../sa-exim_$(VERSION).orig.tar.gz ; \
#        else \
#	    wget http://marc.merlins.org/linux/sa-exim-$(VERSION).tar.gz; \
#	    mv sa-exim-$(VERSION).tar.gz ../sa-exim_$(VERSION).orig.tar.gz; \
#        fi
#
#
#debian/rules:
#	@wget http://marc.merlins.org/linux/exim/files/debian/sa-exim_diff.gz
#	@zcat sa-exim_diff.gz | patch -s -p1
#	@/bin/rm sa-exim_diff.gz
#	@chmod 755 debian/rules
#

## sa-exim 4.1

=== Makefile ===
--- 
+++ 
@@ -63,7 +63,7 @@
 	@cat sa-exim.conf | grep -v "^#" | tr '\012' '' | sed "s/*//g" | tr '' '\012' >> sa-exim_short.conf
 
 sa-exim.h: sa-exim.c version
-	echo "char *version=\"`cat version` (built `date -R`)\";" > sa-exim.h
+	echo "char *version=\"`cat version` (built `date -R 2>/dev/null || date`)\";" > sa-exim.h
 
 clean:	
 	@-rm -rf $(OBJECTS) $(DOCS) $(OTHERTARGETS) build-stamp configure-stamp debian/sa-exim debian/sa-exim.postrm.debhelper debian/sa-exim.substvars debian/files 2>/dev/null

## sa-exim 4.2

=== Makefile ===
--- 
+++ 
@@ -71,6 +71,7 @@
 deb:	../sa-exim_$(VERSION).orig.tar.gz debian/*
 	@make clean
 	@dpkg-buildpackage -uc -us -sd -rfakeroot
+	@make clean
 
 ../sa-exim_$(VERSION).orig.tar.gz: * */*
 	@make clean

## sa-exim 4.2.1

=== Makefile ===
--- 
+++ 
@@ -48,11 +48,11 @@
 
 ACKNOWLEDGEMENTS: Acknowledgements.html
 	@echo "Generating $@"
-	@lynx -dump -nolist $< > $@
+	@links -dump $< > $@
 
 CHANGELOG: Changelog.html
 	@echo "Generating $@"
-	@lynx -dump -nolist $< > $@
+	@links -dump $< > $@
 
 sa.html: Changelog.html Acknowledgements.html sa.html.template
 	@echo "Generating $@"

=== debian/changelog ===
sa-exim (4.2.1-22) unstable; urgency=low

  * Convert to git/gbp and move packaging repository to salsa.debian.org.
  * Convert to dh and use debhelper-compat dependency instead of
    debian/compat (Closes: #876753).
  * Pass SUFF='' also to make clean (Closes: #1045701).
  * Correct Lintian override for accept.so.

 -- Magnus Holmgren <holmgren@debian.org>  Sat, 15 Feb 2025 23:46:46 +0100

sa-exim (4.2.1-21) unstable; urgency=medium

  * localscan-6.0.patch: Update call to smtp_printf() to work with newer
    API (Closes: #1075485, #1020390).
  * printf-warnings.patch: Eliminate most compiler warnings (Closes:
    #943570).

 -- Magnus Holmgren <holmgren@debian.org>  Sun, 12 Jan 2025 21:08:30 +0100

sa-exim (4.2.1-20) unstable; urgency=medium

  * Rebuild against current exim4 (Closes: #981398).
  * Upgrade to Debhelper compat level 12.
  * Bump Standards-Version to 4.5.1.
  * encoding.patch: Change a single letter in Acknowledgements.html from
    Latin-1 to UTF-8 and add a charset meta tag to sa.html.
  * Leave out redundant Acknowledgements.html from binary package.
  * Add Lintian override for accept.so missing dependency information
    (it's a dummy local_scan plugin that has no dependencies). Drop unused
    virtual-package-depends-without-real-package-depends override.

 -- Magnus Holmgren <holmgren@debian.org>  Sat, 13 Feb 2021 18:57:42 +0100

sa-exim (4.2.1-19) unstable; urgency=medium

  * no_eval.patch: [CVE-2019-19920] Manually parse option string in
    Greylisting plugin, avoiding use of eval() (Closes: #946829, #947198).
  * Bump Standards-Version to 4.5.0.

 -- Magnus Holmgren <holmgren@debian.org>  Sat, 08 Feb 2020 22:53:50 +0100

sa-exim (4.2.1-18) unstable; urgency=medium

  * Build with -DLOCAL_SCAN.
  * sprintf_no_format_string.patch: With exim 4.93, string_sprintf()
    requires at least two arguments (Closes: #943571). Thanks to Andreas
    Metzler.

 -- Magnus Holmgren <holmgren@debian.org>  Sat, 23 Nov 2019 22:40:24 +0100

sa-exim (4.2.1-17) unstable; urgency=medium

  * remove-header-crs.patch (new): Strip out carriage returns from header
    lines returned by spamd when the spool file is in wire format
    (Probably closes: #879687; it's a bit unclear what the bug is about).
  * api-limitation.patch: Do expansion of $primary_hostname on every call;
    for some reason, it were getting overwritten between calls despite
    using the permanent memory pool in accordance with Exim documentation.
    Also start using body_linecount again since it's now part of the API,
    but don't update it when it's zero, indicating that the spool file is
    in wire format.

 -- Magnus Holmgren <holmgren@debian.org>  Wed, 08 May 2019 23:11:16 +0200

sa-exim (4.2.1-16) unstable; urgency=low

  * reproducible-build.patch: Make ACKNOWLEDGEMENTS always UTF-8 encoded
    rather than depending on the environment.

 -- Magnus Holmgren <holmgren@debian.org>  Tue, 02 Aug 2016 23:08:31 +0200

sa-exim (4.2.1-15) unstable; urgency=low

  * reproducible-build.patch (new): Make build reproducible by replacing
    the build date with the source date via ${SOURCE_DATE_EPOCH} when
    available (Closes: #831649).  Thanks to Chris Lamb.
  * greylisting-ipv6.patch (new): Finally add IPv6 support to the
    greylisting plugin (Closes: #508161). Replaces grey-only-ipv4.patch.
    Based on Robert Tasarz's patch, though I decided to do things a little
    differently by keeping the greylistfourthbyte option for backwards
    compatibility and not adding separate options for IPv4 and IPv6 at
    this time. Also, with that option enabled, there will only be one
    directory level for all the last 64 bits of an IPv6 address.
  * delete-ext-html-references.patch (new): sa.html, which is shipped in
    the doc directory, is a copy of the author's webpage on sa-exim from
    his website, but without the images or linked pages, which means that
    most of the images and links don't work, except the SourceForge logo,
    which was fetched from sourceforge.net, causing a privacy concern. We
    drop the images and make the non-absolute links relative to
    http://marc.merlins.org/linux/exim/.
  * postinst, postrm: Remove hard-coded path to invoke-rc.d.
  * postrm: On purge, always delete the greylisting tuplets directory
    first. Normally, /var/spool/sa-exim is then empty and can be removed
    without asking the user, avoiding leaving unowned files (Closes:
    #657140).
  * greylist-lint.patch: disable greylisting plugin during spamassassin
    --lint to avoid warnings about missing headers (Closes: #760860).
    Thanks to Chaskiel Grundman.
  * Use dpkg-buildflags.
  * Bump Standards-Version to 3.9.8.
  * Override Lintian warning about virtual exim4-localscanapi dependency
    regardless of API version.

 -- Magnus Holmgren <holmgren@debian.org>  Fri, 22 Jul 2016 11:26:45 +0200

sa-exim (4.2.1-14) unstable; urgency=low

  * Updated Danish and Dutch Debconf template translations (Closes:
    #608447, #634314).
  * Drop the defaults for SAspamcHost and SAspamcPort, deferring to spamc
    as to what the defaults will be if those options are not set in
    sa-exim.conf (Closes: #506571).
  * The "nobody" user and "nogroup" group should not own files. Therefore,
    create /var/spool/sa-exim/tuplets with Debian-exim as owner on new
    installations and run greylistclean as Debian-exim by default. Don't
    change ownership of already existing /var/spool/sa-exim or
    /var/spool/sa-exim/tuplets, since the local admin may have different
    preferences, but give the Debian-exim group the write permission it
    needs if /var/spool/sa-exim/tuplets is owned by "nobody" and spamd
    runs as the calling user (Closes: #563492). Add documentation to
    README.Debian and remove recommendation to run spamd as "nobody" from
    README and README.greylisting.
  * Some tidying of debian/rules and the packaging in general:
    * Add build-arch and build-indep targets.


=== debian/control ===
Source: sa-exim
Section: mail
Priority: optional
Maintainer: Magnus Holmgren <holmgren@debian.org>
Build-Depends: debhelper-compat (= 12), links, exim4-dev
Standards-Version: 4.5.1
Vcs-Git: https://salsa.debian.org/holmgren/sa-exim.git
Vcs-Browser: https://salsa.debian.org/holmgren/sa-exim
Homepage: http://marc.merlins.org/linux/exim/sa.html

Package: sa-exim
Architecture: any
Depends: ${exim:Depends}, spamc, ${shlibs:Depends}, ${misc:Depends},
 debconf (>= 1.2.0) | debconf-2.0, libnetaddr-ip-perl
Recommends: ${perl:Depends}
Suggests: spamassassin
Description: SpamAssassin filter for Exim
 SA-Exim integrates SpamAssassin filtering at SMTP time with the Exim
 v4 MTA. It may be used to reject incoming mails before they arrive, or
 even to tie up the sender's resources by slowing down the connection
 ("teergrubing").
 .
 Most of the functionality of this package can also be achieved
 using the exiscan ACL conditions built into the "heavy" Exim daemon,
 exim-daemon-heavy. Use this package if you need SpamAssassin's
 report_safe feature, or if you want to have easier control over the
 header fields added, without using the report template to add multiple
 fields.

=== debian/rules ===
#!/usr/bin/make -f
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- BUILDCFLAGS='-DLOCAL_SCAN -I/usr/include/exim4 -fPIC $$(CPPFLAGS) $$(CFLAGS)' \
	  CPPFLAGS='$(CPPFLAGS)' CFLAGS='$(CFLAGS)' LDFLAGS='-shared $(LDFLAGS)' SUFF=''

override_dh_auto_clean:
	dh_auto_clean -- SUFF=''

override_dh_installcron:
	dh_installcron --name=greylistclean

override_dh_installchangelogs:
	dh_installchangelogs Changelog.html

override_dh_shlibdeps:
	dh_shlibdeps
	echo "exim:Depends=exim4-localscanapi-`exim4-localscan-plugin-config --localscan-apiversion`" \
	   >> debian/sa-exim.substvars

=== debian/watch ===
version=3

http://marc.merlins.org/linux/exim/sa.html files/sa-exim-(\d+(?:\.\d+)*)\.tar\.gz
